%  eigen1.m
% Matlab file for Part 1 of the Eigenvalues and 
% Eigenvectors module in the Linear Algebra Collection

disp('*********************************************')
disp('Part 1:  Commands related to eigenvalues ')
disp('         and eigenvectors ')
disp('*********************************************')
disp('  ')    

    format short
    
    disp('Step 1:')
    disp('Enter the 3 by 3 matrix A:')
    disp(' ')
    disp('   A = [2,0,0; -8,4,-6; 8,1,9]  ')
    disp(' ')
    disp('---------------------------------------------')
    disp('Calculate the characteristic polynomial of A')
    disp('by hand.  Use MATLAB comments in your diary ')
    disp('file to explain your steps and record your result.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 2: ')
    disp('The following MATLAB commands construct the ')
    disp('characteristic polynomial of A.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms lam ')
    disp('  Cmat = A - lam*eye(3) ')
    disp('  result=det(Cmat) ')
    disp('  cpoly = expand(result) ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 3:')
    disp('Factor the characteristic polynomial by hand')
    disp('and find the roots.  Record your results using ')
    disp('MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 3 (cont.): ')
    disp('The following MATLAB commands factor the ')
    disp('characteristic polynomial and find the roots.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  facs = factor(cpoly) ')
    disp('  roots = solve(cpoly) ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 4: ')
    disp('The following MATLAB command finds the ')
    disp('eigenvalues of A directly.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  eigvals=eig(A) ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 5: ')
    disp('The following MATLAB command finds the basis ')
    disp('for the null space of C = 6*I - A. ')
    disp(' ')
    disp('(The ''r'' gives basis vectors with rational ')
    disp('components.  The built-in eigenvector finder ')
    disp(' ')
    disp('normalizes the eigenvectors to have length one. ')
    disp('Enter: ')
    disp(' ')
    disp('  basisN = null( 6*eye(3) - A, ''r'') ')
    disp('  normalv = basisN./norm(basisN) ')
    disp(' ')
    disp('------------------------------------------------')
    disp('Explain your result using MATLAB comments.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------')
    disp('Step 6: ')
    disp('The following MATLAB commands find the eigenvectors')
    disp('of A directly. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  [P,D]=eig(A) ')
    disp('  eigvec1 = P(:,1) ')
    disp('  eigvec2 = P(:,2) ')
    disp('  eigvec3 = P(:,3) ')
    disp(' ')
    disp('------------------------------------------------')
    disp('Explain the output you see using MATLAB comments.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------')
    disp('Step 7: ')
    disp('We already have P from above.  Let''s calcuate')
    disp('inv(P)*A*P.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  inv(P)*A*P ')
    disp(' ')
    disp('------------------------------------------------')
    disp('Note how this compares to D in step 6.  Explain')
    disp('your result by using MATLAB comments in your')
    disp('diary file.')
    disp(' ')
    disp(' ')
    disp('----------------------------------------------')
    disp('To go on to part 2 of this module, ')
    disp('type: eigen2')
    disp(' ')